onClipEvent(load){
   function newlevel()
   {
      clearbrickclips();
      _global.droot.maze.brickclipno = 0;
      _global.droot.maze.highestrow = -1;
      growth = new Array();
      seed(seeddensity);
      growing = true;
      growinterval = setInterval(grow,10);
   }
   function Grower(x, y)
   {
      var _loc1_ = this;
      _loc1_.x = x;
      _loc1_.y = y;
      _loc1_.type = 0;
      _loc1_.die = function()
      {
         _global.droot.arrayRemove(growth,this);
      };
      _loc1_.grow = function()
      {
      };
      _loc1_.engulf = function(nx, ny)
      {
         var _loc1_ = this;
         _loc1_.x = nx;
         _loc1_.y = ny;
         placebrick(nx,ny,_loc1_.type);
      };
   }
   function Trunk(nx, ny)
   {
      var _loc1_ = this;
      _loc1_.superClass = Grower;
      _loc1_.superClass(nx,ny);
      _loc1_.type = 0.5;
      placebrick(x,y,_loc1_.type);
      _loc1_.grow = function()
      {
         var _loc1_ = this;
         if(mutate(0.1))
         {
            if(hasspace(_loc1_.x - 1,_loc1_.y))
            {
               growth.push(new Branch(_loc1_.x - 1,_loc1_.y,-1));
            }
            if(hasspace(_loc1_.x + 1,_loc1_.y))
            {
               growth.push(new Branch(_loc1_.x + 1,_loc1_.y,1));
            }
            if(mutate(0.1))
            {
               _loc1_.die();
            }
         }
         else if(hasspace(_loc1_.x,_loc1_.y + 1))
         {
            _loc1_.engulf(_loc1_.x,_loc1_.y + 1);
         }
         else
         {
            _loc1_.die();
         }
      };
   }
   function Branch(x, y, direction)
   {
      var _loc1_ = this;
      _loc1_.superClass = Grower;
      _loc1_.superClass(x,y);
      _loc1_.direction = direction;
      _loc1_.type = 1;
      placebrick(x,y,_loc1_.type);
      _loc1_.grow = function()
      {
         var _loc1_ = this;
         if(mutate(0.15))
         {
            if(hasspace(_loc1_.x,_loc1_.y + 2))
            {
               _loc1_.engulf(_loc1_.x,_loc1_.y + 1);
            }
         }
         else if(mutate(0.1))
         {
            if(hasspace(_loc1_.x,_loc1_.y + 2))
            {
               growth.push(new Trunk(_loc1_.x,_loc1_.y + 1));
               _loc1_.die();
            }
         }
         else if(mutate(0.2))
         {
            _loc1_.die();
         }
         else if(hasspace(_loc1_.x + _loc1_.direction,_loc1_.y))
         {
            _loc1_.engulf(_loc1_.x + _loc1_.direction,_loc1_.y);
         }
         else
         {
            _loc1_.die();
         }
      };
   }
   function seed(d)
   {
      var num = Math.max(1,Math.ceil(gridw * d));
      var _loc2_ = new Array(gridw);
      var _loc1_ = 0;
      while(_loc1_ < gridw)
      {
         _loc2_[_loc1_] = _loc1_;
         _loc1_ = _loc1_ + 1;
      }
      _loc1_ = num;
      while(_loc1_ > 0)
      {
         var _loc3_ = Math.floor(Math.random() * (_loc2_.length - 1) + 0.5);
         var loc = _loc2_.splice(_loc3_,1).pop();
         growth.push(new Trunk(loc,0));
         _loc1_ = _loc1_ - 1;
      }
   }
   function grow()
   {
      var _loc1_ = _global;
      for(var _loc2_ in growth)
      {
         growth[_loc2_].grow();
      }
      _loc1_.droot.growersActive = growth.length;
      if(growth.length < 1 || density(_loc1_.droot.maze.grid) > targetdensity)
      {
         growing = false;
         clearInterval(growinterval);
         makebrickarray();
         _loc1_.droot.maze.bricks = _root.shuffle(_loc1_.droot.maze.bricks);
         _loc1_.droot.maze.fbricks = _root.shuffle(_loc1_.droot.maze.fbricks);
         _loc1_.droot.doozers.makedoozers();
      }
   }
   function makebrickarray()
   {
      _global.droot.maze.bricks = new Array();
      _global.droot.maze.fbricks = new Array();
      var _loc3_ = 0;
      while(_loc3_ < gridw)
      {
         var _loc2_ = 0;
         while(_loc2_ < gridh)
         {
            if(hasbrick(_loc3_,_loc2_))
            {
               var _loc1_ = new Object();
               _loc1_.i = _loc3_;
               _loc1_.j = _loc2_;
               _loc1_.id = "brick" + Math.ceil(Math.random() * 3);
               _global.droot.maze.bricks.push(_loc1_);
               _global.droot.maze.fbricks.push(_loc1_);
            }
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      mazemade = true;
   }
   function clearbrickclips()
   {
      mazemade = false;
      var _loc1_ = 0;
      while(_loc1_ < _global.droot.maze.brickclipno)
      {
         var _loc3_ = "brick" + _loc1_;
         var _loc2_ = _global.droot.maze[_loc3_];
         if(_loc2_ != undefined)
         {
            _loc2_.deleteMovieClip(_global.droot.maze[_loc3_]);
         }
         _loc1_ = _loc1_ + 1;
      }
   }
   function hasspace(x, y)
   {
      var _loc1_ = x;
      var _loc2_ = y;
      if(!inbounds(_loc1_,_loc2_))
      {
         return false;
      }
      if(hasbrick(_loc1_,_loc2_))
      {
         return false;
      }
      if(_loc1_ > 2 && (!hasbrick(_loc1_ - 1,_loc2_) && hasbrick(_loc1_ - 2,_loc2_)))
      {
         return false;
      }
      if(_loc1_ < gridw - 2 && (!hasbrick(_loc1_ + 1,_loc2_) && hasbrick(_loc1_ + 2,_loc2_)))
      {
         return false;
      }
      return true;
   }
   function placebrick(x, y, type)
   {
      _global.droot.maze.grid[y * gridw + x] = type;
   }
   function eatbrick(x, y)
   {
      _global.droot.maze.grid[y * gridw + x] = 0;
   }
   function rendergrid()
   {
      var _loc2_ = 0;
      while(_loc2_ < gridw)
      {
         var _loc1_ = 0;
         while(_loc1_ < gridh)
         {
            if(hasbrick(_loc2_,_loc1_))
            {
               drawbrick(_loc2_,_loc1_);
            }
            _loc1_ = _loc1_ + 1;
         }
         _loc2_ = _loc2_ + 1;
      }
   }
   function mutate(p)
   {
      if(Math.random() <= p)
      {
         return true;
      }
      return false;
   }
   function density(arr)
   {
      var _loc1_ = arr;
      var _loc2_ = 0;
      for(var _loc3_ in _loc1_)
      {
         if(_loc1_[_loc3_] > 0)
         {
            _loc2_ = _loc2_ + 1;
         }
      }
      return _loc2_ / _loc1_.length;
   }
   function drawbrick(x, y)
   {
      this.drawCircle(bricksize * x + halfbrick,bricksize * y + halfbrick,halfbrick,1,11510644,221,50);
   }
   function drawbranch(x, y)
   {
      this.drawCircle(bricksize * x + halfbrick,bricksize * y + halfbrick,halfbrick,1,44916,16711901,100);
   }
   function hasbrick(x, y)
   {
      return _global.droot.maze.grid[y * gridw + x] == 1;
   }
   function inbounds(i, j)
   {
      if(i >= 0 && j >= 0 && i < gridw && j < gridh)
      {
         return true;
      }
      return false;
   }
   function drawCircle(xpos, ypos, radius, lWidth, lColor, fColor, fAlpha)
   {
      x = xpos;
      y = ypos;
      r = radius;
      u = r * 0.4086;
      v = r * 0.7071;
      with(_global.droot.doozers)
      {
         lineStyle(lWidth,lColor,100);
         beginFill(fColor,fAlpha);
         moveTo(x - r,y);
         curveTo(x - r,y - u,x - v,y - v);
         curveTo(x - u,y - r,x,y - r);
         curveTo(x + u,y - r,x + v,y - v);
         curveTo(x + r,y - u,x + r,y);
         curveTo(x + r,y + u,x + v,y + v);
         curveTo(x + u,y + r,x,y + r);
         curveTo(x - u,y + r,x - v,y + v);
         curveTo(x - r,y + u,x - r,y);
         endFill();
      }
   }
   gridw = _global.droot.gridw;
   gridh = _global.droot.gridh;
   bricksize = _global.droot.bricksize;
   halfbrick = _global.droot.halfbrick;
   seeddensity = 0.2;
   targetdensity = 0.4;
}
